AsExternalTypeSerializer
Date: 2016-12-04

com.fasterxml.jackson.databind.jsontype.impl

## Class AsExternalTypeSerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.jsontype.TypeSerializer
  - - com.fasterxml.jackson.databind.jsontype.impl.TypeSerializerBase
    - - com.fasterxml.jackson.databind.jsontype.impl.AsExternalTypeSerializer

-     public class AsExternalTypeSerializer
      extends TypeSerializerBase

  Type serializer that preferably embeds type information as an "external" type property; embedded in enclosing JSON object. Note that this serializer should only be used when value is being output at JSON Object context; otherwise it can not work reliably, and will have to revert operation similar to `AsPropertyTypeSerializer`.

  Note that implementation of serialization is bit cumbersome as we must serialized external type id AFTER object; this because callback only occurs after field name has been written.

  Also note that this type of type id inclusion will NOT try to make use of native Type Ids, even if those exist.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.lang.String` | `_typePropertyName`

    - ### Fields inherited from class com.fasterxml.jackson.databind.jsontype.impl.TypeSerializerBase

      `_idResolver, _property`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AsExternalTypeSerializer(TypeIdResolver idRes, BeanProperty property, java.lang.String propName)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `_writeArrayPrefix(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen)`
    `protected void` | `_writeArraySuffix(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen, java.lang.String typeId)`
    `protected void` | `_writeObjectPrefix(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen)`
    `protected void` | `_writeObjectSuffix(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen, java.lang.String typeId)`
    `protected void` | `_writeScalarPrefix(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen)`
    `protected void` | `_writeScalarSuffix(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen, java.lang.String typeId)`
    `AsExternalTypeSerializer` | `forProperty(BeanProperty prop)` Method called to create contextual version, to be used for values of given property.
    `java.lang.String` | `getPropertyName()` Name of property that contains type information, if property-based inclusion is used.
    `com.fasterxml.jackson.annotation.JsonTypeInfo.As` | `getTypeInclusion()` Accessor for type information inclusion method that serializer uses; indicates how type information is embedded in resulting JSON.
    `void` | `writeCustomTypePrefixForArray(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen, java.lang.String typeId)`
    `void` | `writeCustomTypePrefixForObject(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen, java.lang.String typeId)` Method called to write initial part of type information for given value, when it will be output as JSON Object value (not as JSON Array or scalar), using specified custom type id instead of calling `TypeIdResolver`.
    `void` | `writeCustomTypePrefixForScalar(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen, java.lang.String typeId)` Method called to write initial part of type information for given value, when it will be output as scalar JSON value (not as JSON Object or Array), using specified custom type id instead of calling `TypeIdResolver`.
    `void` | `writeCustomTypeSuffixForArray(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen, java.lang.String typeId)`
    `void` | `writeCustomTypeSuffixForObject(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen, java.lang.String typeId)`
    `void` | `writeCustomTypeSuffixForScalar(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen, java.lang.String typeId)`
    `void` | `writeTypePrefixForArray(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen)` Method called to write initial part of type information for given value, when it will be output as JSON Array value (not as JSON Object or scalar).
    `void` | `writeTypePrefixForArray(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen, java.lang.Class<?> type)` Alternative version of the prefix-for-array method, which is given actual type to use (instead of using exact type of the value); typically a super type of actual value type
    `void` | `writeTypePrefixForObject(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen)` Method called to write initial part of type information for given value, when it will be output as JSON Object value (not as JSON Array or scalar).
    `void` | `writeTypePrefixForObject(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen, java.lang.Class<?> type)` Alternative version of the prefix-for-object method, which is given actual type to use (instead of using exact type of the value); typically a super type of actual value type
    `void` | `writeTypePrefixForScalar(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen)` Method called to write initial part of type information for given value, when it will be output as scalar JSON value (not as JSON Object or Array).
    `void` | `writeTypePrefixForScalar(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen, java.lang.Class<?> type)` Alternative version of the prefix-for-scalar method, which is given actual type to use (instead of using exact type of the value); typically a super type of actual value type
    `void` | `writeTypeSuffixForArray(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen)` Method called after value has been serialized, to close any scopes opened by earlier matching call to `TypeSerializer.writeTypeSuffixForScalar(java.lang.Object, com.fasterxml.jackson.core.JsonGenerator)`.
    `void` | `writeTypeSuffixForObject(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen)` Method called after value has been serialized, to close any scopes opened by earlier matching call to `TypeSerializer.writeTypePrefixForObject(java.lang.Object, com.fasterxml.jackson.core.JsonGenerator)`.
    `void` | `writeTypeSuffixForScalar(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen)` Method called after value has been serialized, to close any scopes opened by earlier matching call to `TypeSerializer.writeTypePrefixForScalar(java.lang.Object, com.fasterxml.jackson.core.JsonGenerator)`.

    - ### Methods inherited from class com.fasterxml.jackson.databind.jsontype.impl.TypeSerializerBase

      `getTypeIdResolver, handleMissingId, idFromValue, idFromValueAndType`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _typePropertyName

          protected final java.lang.String _typePropertyName

  - ### Constructor Detail

    - #### AsExternalTypeSerializer

          public AsExternalTypeSerializer(TypeIdResolver idRes,
                                  BeanProperty property,
                                  java.lang.String propName)

  - ### Method Detail

    - #### forProperty

          public AsExternalTypeSerializer forProperty(BeanProperty prop)

      Description copied from class: `TypeSerializer`
      Method called to create contextual version, to be used for values of given property. This may be the type itself (as is the case for bean properties), or values contained (for `Collection` or `Map` valued properties).
      Specified by:
        `forProperty` in class `TypeSerializer`

    - #### getPropertyName

          public java.lang.String getPropertyName()

      Description copied from class: `TypeSerializer`
      Name of property that contains type information, if property-based inclusion is used.
      Overrides:
        `getPropertyName` in class `TypeSerializerBase`

    - #### getTypeInclusion

          public com.fasterxml.jackson.annotation.JsonTypeInfo.As getTypeInclusion()

      Description copied from class: `TypeSerializer`
      Accessor for type information inclusion method that serializer uses; indicates how type information is embedded in resulting JSON.
      Specified by:
        `getTypeInclusion` in class `TypeSerializerBase`

    - #### writeTypePrefixForObject

          public void writeTypePrefixForObject(java.lang.Object value,
                                      com.fasterxml.jackson.core.JsonGenerator gen)
                                        throws java.io.IOException

      Description copied from class: `TypeSerializer`
      Method called to write initial part of type information for given value, when it will be output as JSON Object value (not as JSON Array or scalar). This means that context after call must be JSON Object, meaning that caller can then proceed to output field entries.
      Specified by:
        `writeTypePrefixForObject` in class `TypeSerializer`
      Parameters:
        `value` - Value that will be serialized, for which type information is to be written
        `gen` - Generator to use for writing type information
      Throws:
        `java.io.IOException`

    - #### writeTypePrefixForObject

          public void writeTypePrefixForObject(java.lang.Object value,
                                      com.fasterxml.jackson.core.JsonGenerator gen,
                                      java.lang.Class<?> type)
                                        throws java.io.IOException

      Description copied from class: `TypeSerializer`
      Alternative version of the prefix-for-object method, which is given actual type to use (instead of using exact type of the value); typically a super type of actual value type
      Overrides:
        `writeTypePrefixForObject` in class `TypeSerializer`
      Throws:
        `java.io.IOException`

    - #### writeTypePrefixForArray

          public void writeTypePrefixForArray(java.lang.Object value,
                                     com.fasterxml.jackson.core.JsonGenerator gen)
                                       throws java.io.IOException

      Description copied from class: `TypeSerializer`
      Method called to write initial part of type information for given value, when it will be output as JSON Array value (not as JSON Object or scalar). This means that context after call must be JSON Array, that is, there must be an open START_ARRAY to write contents in.
      Specified by:
        `writeTypePrefixForArray` in class `TypeSerializer`
      Parameters:
        `value` - Value that will be serialized, for which type information is to be written
        `gen` - Generator to use for writing type information
      Throws:
        `java.io.IOException`

    - #### writeTypePrefixForArray

          public void writeTypePrefixForArray(java.lang.Object value,
                                     com.fasterxml.jackson.core.JsonGenerator gen,
                                     java.lang.Class<?> type)
                                       throws java.io.IOException

      Description copied from class: `TypeSerializer`
      Alternative version of the prefix-for-array method, which is given actual type to use (instead of using exact type of the value); typically a super type of actual value type
      Overrides:
        `writeTypePrefixForArray` in class `TypeSerializer`
      Throws:
        `java.io.IOException`

    - #### writeTypePrefixForScalar

          public void writeTypePrefixForScalar(java.lang.Object value,
                                      com.fasterxml.jackson.core.JsonGenerator gen)
                                        throws java.io.IOException

      Description copied from class: `TypeSerializer`
      Method called to write initial part of type information for given value, when it will be output as scalar JSON value (not as JSON Object or Array). This means that the context after call can not be that of JSON Object; it may be Array or root context.
      Specified by:
        `writeTypePrefixForScalar` in class `TypeSerializer`
      Parameters:
        `value` - Value that will be serialized, for which type information is to be written
        `gen` - Generator to use for writing type information
      Throws:
        `java.io.IOException`

    - #### writeTypePrefixForScalar

          public void writeTypePrefixForScalar(java.lang.Object value,
                                      com.fasterxml.jackson.core.JsonGenerator gen,
                                      java.lang.Class<?> type)
                                        throws java.io.IOException

      Description copied from class: `TypeSerializer`
      Alternative version of the prefix-for-scalar method, which is given actual type to use (instead of using exact type of the value); typically a super type of actual value type
      Overrides:
        `writeTypePrefixForScalar` in class `TypeSerializer`
      Throws:
        `java.io.IOException`

    - #### writeTypeSuffixForObject

          public void writeTypeSuffixForObject(java.lang.Object value,
                                      com.fasterxml.jackson.core.JsonGenerator gen)
                                        throws java.io.IOException

      Description copied from class: `TypeSerializer`
      Method called after value has been serialized, to close any scopes opened by earlier matching call to `TypeSerializer.writeTypePrefixForObject(java.lang.Object, com.fasterxml.jackson.core.JsonGenerator)`. It needs to write closing END_OBJECT marker, and any other decoration that needs to be matched.
      Specified by:
        `writeTypeSuffixForObject` in class `TypeSerializer`
      Throws:
        `java.io.IOException`

    - #### writeTypeSuffixForArray

          public void writeTypeSuffixForArray(java.lang.Object value,
                                     com.fasterxml.jackson.core.JsonGenerator gen)
                                       throws java.io.IOException

      Description copied from class: `TypeSerializer`
      Method called after value has been serialized, to close any scopes opened by earlier matching call to `TypeSerializer.writeTypeSuffixForScalar(java.lang.Object, com.fasterxml.jackson.core.JsonGenerator)`. It needs to write closing END_ARRAY marker, and any other decoration that needs to be matched.
      Specified by:
        `writeTypeSuffixForArray` in class `TypeSerializer`
      Throws:
        `java.io.IOException`

    - #### writeTypeSuffixForScalar

          public void writeTypeSuffixForScalar(java.lang.Object value,
                                      com.fasterxml.jackson.core.JsonGenerator gen)
                                        throws java.io.IOException

      Description copied from class: `TypeSerializer`
      Method called after value has been serialized, to close any scopes opened by earlier matching call to `TypeSerializer.writeTypePrefixForScalar(java.lang.Object, com.fasterxml.jackson.core.JsonGenerator)`. Actual action to take may depend on various factors, but has to match with action `TypeSerializer.writeTypePrefixForScalar(java.lang.Object, com.fasterxml.jackson.core.JsonGenerator)` did (close array or object; or do nothing).
      Specified by:
        `writeTypeSuffixForScalar` in class `TypeSerializer`
      Throws:
        `java.io.IOException`

    - #### writeCustomTypePrefixForScalar

          public void writeCustomTypePrefixForScalar(java.lang.Object value,
                                            com.fasterxml.jackson.core.JsonGenerator gen,
                                            java.lang.String typeId)
                                              throws java.io.IOException

      Description copied from class: `TypeSerializer`
      Method called to write initial part of type information for given value, when it will be output as scalar JSON value (not as JSON Object or Array), using specified custom type id instead of calling `TypeIdResolver`. This means that the context after call can not be that of JSON Object; it may be Array or root context.
      Specified by:
        `writeCustomTypePrefixForScalar` in class `TypeSerializer`
      Parameters:
        `value` - Value that will be serialized, for which type information is to be written
        `gen` - Generator to use for writing type information
        `typeId` - Exact type id to use
      Throws:
        `java.io.IOException`

    - #### writeCustomTypePrefixForObject

          public void writeCustomTypePrefixForObject(java.lang.Object value,
                                            com.fasterxml.jackson.core.JsonGenerator gen,
                                            java.lang.String typeId)
                                              throws java.io.IOException

      Description copied from class: `TypeSerializer`
      Method called to write initial part of type information for given value, when it will be output as JSON Object value (not as JSON Array or scalar), using specified custom type id instead of calling `TypeIdResolver`. This means that context after call must be JSON Object, meaning that caller can then proceed to output field entries.
      Specified by:
        `writeCustomTypePrefixForObject` in class `TypeSerializer`
      Parameters:
        `value` - Value that will be serialized, for which type information is to be written
        `gen` - Generator to use for writing type information
        `typeId` - Exact type id to use
      Throws:
        `java.io.IOException`

    - #### writeCustomTypePrefixForArray

          public void writeCustomTypePrefixForArray(java.lang.Object value,
                                           com.fasterxml.jackson.core.JsonGenerator gen,
                                           java.lang.String typeId)
                                             throws java.io.IOException

      Specified by:
        `writeCustomTypePrefixForArray` in class `TypeSerializer`
      Throws:
        `java.io.IOException`

    - #### writeCustomTypeSuffixForScalar

          public void writeCustomTypeSuffixForScalar(java.lang.Object value,
                                            com.fasterxml.jackson.core.JsonGenerator gen,
                                            java.lang.String typeId)
                                              throws java.io.IOException

      Specified by:
        `writeCustomTypeSuffixForScalar` in class `TypeSerializer`
      Throws:
        `java.io.IOException`

    - #### writeCustomTypeSuffixForObject

          public void writeCustomTypeSuffixForObject(java.lang.Object value,
                                            com.fasterxml.jackson.core.JsonGenerator gen,
                                            java.lang.String typeId)
                                              throws java.io.IOException

      Specified by:
        `writeCustomTypeSuffixForObject` in class `TypeSerializer`
      Throws:
        `java.io.IOException`

    - #### writeCustomTypeSuffixForArray

          public void writeCustomTypeSuffixForArray(java.lang.Object value,
                                           com.fasterxml.jackson.core.JsonGenerator gen,
                                           java.lang.String typeId)
                                             throws java.io.IOException

      Specified by:
        `writeCustomTypeSuffixForArray` in class `TypeSerializer`
      Throws:
        `java.io.IOException`

    - #### _writeScalarPrefix

          protected final void _writeScalarPrefix(java.lang.Object value,
                                com.fasterxml.jackson.core.JsonGenerator gen)
                                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### _writeObjectPrefix

          protected final void _writeObjectPrefix(java.lang.Object value,
                                com.fasterxml.jackson.core.JsonGenerator gen)
                                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### _writeArrayPrefix

          protected final void _writeArrayPrefix(java.lang.Object value,
                               com.fasterxml.jackson.core.JsonGenerator gen)
                                          throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### _writeScalarSuffix

          protected final void _writeScalarSuffix(java.lang.Object value,
                                com.fasterxml.jackson.core.JsonGenerator gen,
                                java.lang.String typeId)
                                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### _writeObjectSuffix

          protected final void _writeObjectSuffix(java.lang.Object value,
                                com.fasterxml.jackson.core.JsonGenerator gen,
                                java.lang.String typeId)
                                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### _writeArraySuffix

          protected final void _writeArraySuffix(java.lang.Object value,
                               com.fasterxml.jackson.core.JsonGenerator gen,
                               java.lang.String typeId)
                                          throws java.io.IOException

      Throws:
        `java.io.IOException`